<?php
/*
	PayAnyWay payment module
*/

	class payanyway {
		var $code, $title, $description, $enabled;
		var $params = array('unit_id' => '', 'limit_ids' => '', 'account_id' => '', 'online' => 1);

		// class constructor
		function payanyway() {
			global $order;

			$this->code = 'payanyway';
			$this->title = MODULE_PAYMENT_PAYANYWAY_TEXT_TITLE;
			$this->description = MODULE_PAYMENT_PAYANYWAY_TEXT_DESCRIPTION;
			$this->sort_order = MODULE_PAYMENT_PAYANYWAY_SORT_ORDER;
			$this->enabled = ((MODULE_PAYMENT_PAYANYWAY_STATUS == 'True') ? true : false);

			if ((int)MODULE_PAYMENT_PAYANYWAY_PREPARE_ORDER_STATUS_ID > 0) {
				$this->order_status = MODULE_PAYMENT_PAYANYWAY_PREPARE_ORDER_STATUS_ID;
			}

			if (is_object($order)) $this->update_status();
		}

		// class methods
		function update_status() {
			global $order;

			if ( ($this->enabled == true) && ((int)MODULE_PAYMENT_PAYANYWAY_ZONE > 0) ) {
				$check_flag = false;
				$check_query = vam_db_query("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_PAYMENT_PAYANYWAY_ZONE . "' and zone_country_id = '" . $order->billing['country']['id'] . "' order by zone_id");
				while ($check = vam_db_fetch_array($check_query)) {
					if ($check['zone_id'] < 1) {
						$check_flag = true;
						break;
					} elseif ($check['zone_id'] == $order->billing['zone_id']) {
						$check_flag = true;
						break;
					}
				}

				if ($check_flag == false) {
					$this->enabled = false;
				}
			}
		}

		function javascript_validation() {
			return false;
		}
		
		function selection() {
			if (vam_not_null($this->icon)) $icon = vam_image($this->icon, $this->title);		
			return array('id' => $this->code, 'module' => $this->title, 'icon' => $icon);
		}

		function pre_confirmation_check() {
			return false;
		}

		function confirmation() {
			return false;
		}

		function process_button() {
			return false;
		}

		function before_process() {
			return false;
		}

		function after_process() {
			global $insert_id, $currencies, $languages_id, $order, $cart, $vamPrice;

			if ($this->order_status)
				vam_db_query("UPDATE ".TABLE_ORDERS." SET orders_status='".$this->order_status."' WHERE orders_id='".$insert_id."'");
			
			switch (MODULE_PAYMENT_PAYANYWAY_TEST_MODE) {
				case 'Real':
					$test_mode = '0';
					break;
				case 'Test':
					$test_mode = '1';
					break;
			}
			
			$lang_query = vam_db_query("select code from " . TABLE_LANGUAGES . " where languages_id = '" . (int)$languages_id . "'");
			$lang = vam_db_fetch_array($lang_query); 
			
			switch (strtolower($lang['code'])) {
				case 'en':
				case 'ru':
					$language_code = strtolower($lang['code']);
					break;
				default:
					$language_code = strtolower(DEFAULT_LANGUAGE);
			}
			
			$transactionId = date('Ymdhis') . rand (0, 99999);
			
			$amount = str_replace($vamPrice->currencies[MODULE_PAYMENT_PAYANYWAY_CURRENCY_CODE]["thousands_point"],'',$order->info['total']);
			$amount = str_replace($vamPrice->currencies[MODULE_PAYMENT_PAYANYWAY_CURRENCY_CODE]["decimal_point"],'.',$amount);
			if ($_SESSION['currency'] == MODULE_PAYMENT_PAYANYWAY_CURRENCY_CODE) {
				$amount = number_format($amount, 2, '.', '');
			} else {
				$amount = number_format($vamPrice->CalculateCurrEx($amount, MODULE_PAYMENT_PAYANYWAY_CURRENCY_CODE), 2, '.', '');
			}
			
			$currency = ('RUR' == MODULE_PAYMENT_PAYANYWAY_CURRENCY_CODE) ? 'RUB' : MODULE_PAYMENT_PAYANYWAY_CURRENCY_CODE;
			if ($this->params['online']) {
				$action = 'https://' . MODULE_PAYMENT_PAYANYWAY_SERVER . '/assistant.htm?';
			} else {
				$action = vam_href_link('payanyway_invoice.php') . '?';
			}
			
			$_SESSION['cart']->reset(true);

			vam_session_unregister('sendto');
			vam_session_unregister('billto');
			vam_session_unregister('shipping');
			vam_session_unregister('payment');
			vam_session_unregister('comments');
			
			vam_redirect( $action .
								'MNT_ID=' . MODULE_PAYMENT_PAYANYWAY_MERCHANT_ID .
								'&MNT_TRANSACTION_ID=' . $transactionId . 
								'&MNT_AMOUNT=' . $amount .
								'&MNT_CURRENCY_CODE=' . $currency .
								'&MNT_TEST_MODE=' . $test_mode .
								'&MNT_SIGNATURE=' . md5(MODULE_PAYMENT_PAYANYWAY_MERCHANT_ID . $transactionId . $amount . $currency . $test_mode . MODULE_PAYMENT_PAYANYWAY_DATA_INTEGRITY_CODE) .
								'&MNT_SUCCESS_URL=' . vam_href_link(FILENAME_CHECKOUT_SUCCESS, '', 'SSL') .
								'&MNT_FAIL_URL=' . vam_href_link(FILENAME_CHECKOUT_PAYMENT, '', 'SSL') .
								'&paymentSystem.unitId=' . $this->params['unit_id'] .
								'&paymentSystem.limitIds=' . $this->params['limit_ids'] .
								'&paymentSystem.accountId=' . $this->params['account_id'] .
								'&payment_system=' . $this->code .
								'&followup=true' .
								'&javascriptEnabled=true' .
								'&orderId=' . $insert_id .
								'&moneta.locale=' . $language_code);
		}
		
		function output_error() {
			return false;
		}

		function check() {
			if (!isset($this->_check)) {
				$check_query = vam_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_PAYANYWAY_STATUS'");
				$this->_check = vam_db_num_rows($check_query);
			}
			return $this->_check;
		}

		function install() {
			$check_query = vam_db_query("select orders_status_id from " . TABLE_ORDERS_STATUS . " where orders_status_name = 'Preparing [PayAnyWay]' limit 1");

			if (vam_db_num_rows($check_query) < 1) {
				$status_query = vam_db_query("select max(orders_status_id) as status_id from " . TABLE_ORDERS_STATUS);
				$status = vam_db_fetch_array($status_query);

				$status_id = $status['status_id']+1;

				$languages = vam_get_languages();

				for ($i=0, $n=sizeof($languages); $i<$n; $i++) {
					vam_db_query("insert into " . TABLE_ORDERS_STATUS . " (orders_status_id, language_id, orders_status_name) values ('" . $status_id . "', '" . $languages[$i]['id'] . "', 'Preparing [PayAnyWay]')");
				}

				$flags_query = vam_db_query("describe " . TABLE_ORDERS_STATUS . " public_flag");
				if (vam_db_num_rows($flags_query) == 1) {
					vam_db_query("update " . TABLE_ORDERS_STATUS . " set public_flag = 1 and downloads_flag = 0 where orders_status_id = '" . $status_id . "'");
				}
			} else {
				$check = vam_db_fetch_array($check_query);

				$status_id = $check['orders_status_id'];
			} 
		
			vam_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, set_function, date_added) values ('MODULE_PAYMENT_PAYANYWAY_STATUS', 'True', '6', '1', 'vam_cfg_select_option(array(\'True\', \'False\'), ', now())");
			vam_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, date_added) values ('MODULE_PAYMENT_PAYANYWAY_ALLOWED', '', '6', '4', now())");
			vam_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, date_added) values ('MODULE_PAYMENT_PAYANYWAY_SERVER', 'www.payanyway.ru', '6', '2', now())");
			vam_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, date_added) values ('MODULE_PAYMENT_PAYANYWAY_MERCHANT_ID', '', '6', '3', now())");
			vam_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, set_function, date_added) values ('MODULE_PAYMENT_PAYANYWAY_CURRENCY_CODE', 'RUR', '6', '4', 'vam_cfg_select_option(array(\'RUR\', \'EUR\', \'USD\', \'GBP\'), ', now())");
			vam_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, date_added) values ('MODULE_PAYMENT_PAYANYWAY_DATA_INTEGRITY_CODE', '', '6', '4', now())");
			vam_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, set_function, date_added) values ('MODULE_PAYMENT_PAYANYWAY_TEST_MODE', 'Real', '6', '5', 'vam_cfg_select_option(array(\'Real\', \'Test\'), ', now())");
			vam_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, use_function, set_function, date_added) values ('MODULE_PAYMENT_PAYANYWAY_ZONE', '0', '6', '6', 'vam_get_zone_class_title', 'vam_cfg_pull_down_zone_classes(', now())");

			vam_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, date_added) values ('MODULE_PAYMENT_PAYANYWAY_LOGIN', '', '6', '7', now())");
			vam_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, date_added) values ('MODULE_PAYMENT_PAYANYWAY_PASSWORD', '', '6', '8', now())");

			vam_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, set_function, use_function, date_added) values ('MODULE_PAYMENT_PAYANYWAY_PREPARE_ORDER_STATUS_ID', '0', '6', '7', 'vam_cfg_pull_down_order_statuses(', 'vam_get_order_status_name', now())");
			vam_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, set_function, use_function, date_added) values ('MODULE_PAYMENT_PAYANYWAY_ORDER_STATUS_ID', '0', '6', '8', 'vam_cfg_pull_down_order_statuses(', 'vam_get_order_status_name', now())");
			vam_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, date_added) values ('MODULE_PAYMENT_PAYANYWAY_SORT_ORDER', '0', '6', '9', now())");
		}

		function remove() {
			vam_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
		}

		function keys() {
			return array('MODULE_PAYMENT_PAYANYWAY_STATUS', 'MODULE_PAYMENT_PAYANYWAY_ALLOWED', 'MODULE_PAYMENT_PAYANYWAY_LOGIN', 'MODULE_PAYMENT_PAYANYWAY_PASSWORD', 'MODULE_PAYMENT_PAYANYWAY_SERVER', 'MODULE_PAYMENT_PAYANYWAY_MERCHANT_ID', 'MODULE_PAYMENT_PAYANYWAY_CURRENCY_CODE', 'MODULE_PAYMENT_PAYANYWAY_DATA_INTEGRITY_CODE', 'MODULE_PAYMENT_PAYANYWAY_TEST_MODE', 'MODULE_PAYMENT_PAYANYWAY_ZONE', 'MODULE_PAYMENT_PAYANYWAY_PREPARE_ORDER_STATUS_ID', 'MODULE_PAYMENT_PAYANYWAY_ORDER_STATUS_ID', 'MODULE_PAYMENT_PAYANYWAY_SORT_ORDER');
		}
	}
?>
