<?php
/*
	PayAnyWay payment module
*/
	require_once (dirname(__FILE__).'/payanyway.php');

	class payanyway_wallet extends payanyway{
		var $code, $title, $description, $enabled;
		var $params = array('unit_id' => 310212, 'limit_ids' => '310212', 'account_id' => '153', 'online' => 1);

		// class constructor
		function payanyway_wallet() {
			global $order;

			$this->code = 'payanyway_wallet';
			$this->title = MODULE_PAYMENT_PAYANYWAY_WALLET_TEXT_TITLE;
			$this->description = MODULE_PAYMENT_PAYANYWAY_WALLET_TEXT_DESCRIPTION;
			$this->sort_order = MODULE_PAYMENT_PAYANYWAY_WALLET_SORT_ORDER;
			$this->enabled = ((MODULE_PAYMENT_PAYANYWAY_WALLET_STATUS == 'True') ? true : false);

			if ((int)MODULE_PAYMENT_PAYANYWAY_PREPARE_ORDER_STATUS_ID > 0) {
				$this->order_status = MODULE_PAYMENT_PAYANYWAY_PREPARE_ORDER_STATUS_ID;
			}

			if (is_object($order)) $this->update_status();
		}

		// class methods
		function update_status() {
			global $order;

			if ( ($this->enabled == true) && ((int)MODULE_PAYMENT_PAYANYWAY_WALLET_ZONE > 0) ) {
				$check_flag = false;
				$check_query = vam_db_query("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_PAYMENT_PAYANYWAY_WALLET_ZONE . "' and zone_country_id = '" . $order->billing['country']['id'] . "' order by zone_id");
				while ($check = vam_db_fetch_array($check_query)) {
					if ($check['zone_id'] < 1) {
						$check_flag = true;
						break;
					} elseif ($check['zone_id'] == $order->billing['zone_id']) {
						$check_flag = true;
						break;
					}
				}

				if ($check_flag == false) {
					$this->enabled = false;
				}
			}
		}

		function check() {
			if (!isset($this->_check)) {
				$check_query = vam_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_PAYANYWAY_WALLET_STATUS'");
				$this->_check = vam_db_num_rows($check_query);
			}
			return $this->_check;
		}

		function install() {
			$check_query = vam_db_query("select orders_status_id from " . TABLE_ORDERS_STATUS . " where orders_status_name = 'Preparing [PayAnyWay]' limit 1");

			if (vam_db_num_rows($check_query) < 1) {
				$status_query = vam_db_query("select max(orders_status_id) as status_id from " . TABLE_ORDERS_STATUS);
				$status = vam_db_fetch_array($status_query);

				$status_id = $status['status_id']+1;

				$languages = vam_get_languages();

				for ($i=0, $n=sizeof($languages); $i<$n; $i++) {
					vam_db_query("insert into " . TABLE_ORDERS_STATUS . " (orders_status_id, language_id, orders_status_name) values ('" . $status_id . "', '" . $languages[$i]['id'] . "', 'Preparing [PayAnyWay]')");
				}

				$flags_query = vam_db_query("describe " . TABLE_ORDERS_STATUS . " public_flag");
				if (vam_db_num_rows($flags_query) == 1) {
					vam_db_query("update " . TABLE_ORDERS_STATUS . " set public_flag = 1 and downloads_flag = 0 where orders_status_id = '" . $status_id . "'");
				}
			} else {
				$check = vam_db_fetch_array($check_query);

				$status_id = $check['orders_status_id'];
			} 
		
			vam_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, set_function, date_added) values ('MODULE_PAYMENT_PAYANYWAY_WALLET_STATUS', 'True', '6', '1', 'vam_cfg_select_option(array(\'True\', \'False\'), ', now())");
			vam_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, date_added) values ('MODULE_PAYMENT_PAYANYWAY_WALLET_ALLOWED', '', '6', '4', now())");
			vam_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, use_function, set_function, date_added) values ('MODULE_PAYMENT_PAYANYWAY_WALLET_ZONE', '0', '6', '6', 'vam_get_zone_class_title', 'vam_cfg_pull_down_zone_classes(', now())");
			vam_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, date_added) values ('MODULE_PAYMENT_PAYANYWAY_WALLET_SORT_ORDER', '0', '6', '9', now())");
		}

		function remove() {
			vam_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
		}

		function keys() {
			return array('MODULE_PAYMENT_PAYANYWAY_WALLET_STATUS', 'MODULE_PAYMENT_PAYANYWAY_WALLET_ALLOWED', 'MODULE_PAYMENT_PAYANYWAY_WALLET_ZONE', 'MODULE_PAYMENT_PAYANYWAY_WALLET_SORT_ORDER');
		}
	}
?>
