<?php
/*
	PayAnyWay payment module
*/

require ('includes/application_top.php');
// create template elements
$vamTemplate = new vamTemplate;
// include boxes
require (DIR_FS_CATALOG.'templates/'.CURRENT_TEMPLATE.'/source/boxes.php');

require_once (DIR_WS_MODULES . 'payment/MonetaAPI/MonetaWebService.php');

$payment_system = substr($_REQUEST['payment_system'], 10);
require(DIR_WS_LANGUAGES . $_SESSION['language'] . '/modules/payment/payanyway_' . $payment_system . '.php');
require(DIR_WS_LANGUAGES . $_SESSION['language'] . '/modules/payment/payanyway.php');

	if (MODULE_PAYMENT_PAYANYWAY_SERVER == 'www.payanyway.ru') {
		$service = new MonetaWebService("https://www.moneta.ru/services.wsdl", MODULE_PAYMENT_PAYANYWAY_LOGIN, MODULE_PAYMENT_PAYANYWAY_PASSWORD);
	} else {
		$service = new MonetaWebService("https://demo.moneta.ru/services.wsdl", MODULE_PAYMENT_PAYANYWAY_LOGIN, MODULE_PAYMENT_PAYANYWAY_PASSWORD);
	}

	try {
		// получить данные счета
		$request = new MonetaInvoiceRequest();
		$request->payer = $_REQUEST['paymentSystem_accountId'];
		$request->payee = $_REQUEST['MNT_ID'];
		$request->amount = $_REQUEST['MNT_AMOUNT'];
		$request->clientTransaction = $_REQUEST['MNT_TRANSACTION_ID'];

		if ($payment_system == 'post') {
			$operationInfo = new MonetaOperationInfo();
			$a1 = new MonetaKeyValueAttribute();
			$a1->key = 'mailofrussiaindex';
			$a1->value = $_REQUEST['additionalParameters_mailofrussiaSenderIndex'];
			$operationInfo->addAttribute($a1);
			$a2 = new MonetaKeyValueAttribute();
			$a2->key = 'mailofrussiaaddress';
			$a2->value = $_REQUEST['additionalParameters_mailofrussiaSenderAddress'];
			$operationInfo->addAttribute($a2);
			$a3 = new MonetaKeyValueAttribute();
			$a3->key = 'mailofrussianame';
			$a3->value = $_REQUEST['additionalParameters_mailofrussiaSenderName'];
			$operationInfo->addAttribute($a3);
			$request->operationInfo = $operationInfo;
		}
		elseif ($payment_system == 'euroset')
		{
			$operationInfo = new MonetaOperationInfo();
			$a1 = new MonetaKeyValueAttribute();
			$a1->key = 'rapidamphone';
			$a1->value = $_REQUEST['additionalParameters_rapidaPhone'];
			$operationInfo->addAttribute($a1);
			$request->operationInfo = $operationInfo;
		}
		$response = $service->Invoice($request);
		if ($payment_system == 'euroset')
		{
			$response1 = $service->GetOperationDetailsById($response->transaction);
			foreach ($response1->operation->attribute as $attr)
			{
				if ($attr->key == 'rapidatid')
				{
					$transaction_id = $attr->value;
				}
			}
		}
		else
		{
			$transaction_id = $response->transaction;
		}
		
		$invoice->title = INVOICE_TITLE_CREATED;
		$invoice->text_message = (in_array($payment_system, array('post', 'banktransfer'))) ? INVOICE_CREATED : array(INVOICE_CREATED_1,INVOICE_CREATED_2,INVOICE_CREATED_3);
		
		$invoice->status = $response->status;
		$invoice->transaction = str_pad($transaction_id, 10, "0", STR_PAD_LEFT);
		$invoice->system = $payment_system;
		$invoice->amount = $_REQUEST['MNT_AMOUNT']." ".$_REQUEST['MNT_CURRENCY_CODE'];
		
		$breadcrumb->add(NAVBAR_TITLE_1_CHECKOUT_SUCCESS);
		$breadcrumb->add(NAVBAR_TITLE_2_CHECKOUT_SUCCESS);
	}
	catch (Exception $e) {
		$invoice->title = INVOICE_TITLE_FAILED;
		$invoice->status = 'FAILED';
		$invoice->text_message = $e->getMessage();
		
		$breadcrumb->add(NAVBAR_TITLE_1_CHECKOUT_SUCCESS);
		$breadcrumb->add(NAVBAR_TITLE_2_CHECKOUT_FAIL);
	}
	
$vamTemplate->assign('invoice', $invoice);
$vamTemplate->assign('payment_system', $payment_system);
	
require (DIR_WS_INCLUDES.'header.php');


$vamTemplate->caching = 0;
$vamTemplate->assign('language', $_SESSION['language']);
$main_content = $vamTemplate->fetch(CURRENT_TEMPLATE.'/module/payanyway_invoice.html');

$vamTemplate->assign('main_content', $main_content);
$vamTemplate->caching = 0;
if (!defined(RM)) $vamTemplate->load_filter('output', 'note');
$template = (file_exists('templates/'.CURRENT_TEMPLATE.'/'.FILENAME_CHECKOUT_SUCCESS.'.html') ? CURRENT_TEMPLATE.'/'.FILENAME_CHECKOUT_SUCCESS.'.html' : CURRENT_TEMPLATE.'/index.html');
$vamTemplate->display($template);
?>	
